"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PropertyOf = PropertyOf;
const lodash_1 = require("lodash");
const MetadataRegistry_1 = require("../lib/registry/MetadataRegistry");
const Constants_1 = require("../lib/Constants");
function PropertyOf(propertyName, entityOrOptions, options = null) {
    return function (object) {
        if (!options) {
            options = {};
        }
        if ((0, lodash_1.isString)(entityOrOptions) || (0, lodash_1.isFunction)(entityOrOptions)) {
            options.target = entityOrOptions;
        }
        else {
            options = entityOrOptions;
        }
        options.appended = true;
        options.type = object;
        if (propertyName) {
            options.propertyName = propertyName;
        }
        MetadataRegistry_1.MetadataRegistry.$().add(Constants_1.METATYPE_PROPERTY, options);
    };
}
//# sourceMappingURL=PropertyOf.js.map