"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Required = Required;
const lodash_1 = require("lodash");
const AnnotationsHelper_1 = require("../../lib/AnnotationsHelper");
const DefaultValidator_1 = require("../../lib/validation/DefaultValidator");
function Required(options) {
    return function (source, propertyName) {
        const opts = {
            required: true
        };
        if (options) {
            (0, lodash_1.assign)(opts, { validateOptions: { required: {} } });
            (0, lodash_1.assign)(opts.validateOptions.required, options);
        }
        AnnotationsHelper_1.AnnotationsHelper.forPropertyOn(source.constructor, propertyName, opts, 'merge');
    };
}
DefaultValidator_1.DefaultValidator.define({
    name: 'required',
    fn: (value, opts, instance) => {
        if ((0, lodash_1.isUndefined)(value) || (0, lodash_1.isNull)(value)) {
            return false;
        }
        return true;
    },
    defaultOptions: {
        message: 'Property "%propertyName" is required.'
    },
    involveOnOptionKey: 'required'
});
//# sourceMappingURL=Required.js.map