export declare const DEFAULT_NAMESPACE = "default";
export declare const GLOBAL_NAMESPACE = "__global__";
export declare const C_IDENTIFIER = "identifier";
export declare const C_TYPE = "type";
export declare const C_NAME = "name";
export declare const C_INTERNAL_NAME = "internalName";
export declare const C_APPENDED = "appended";
export declare const C_CARDINALITY = "cardinality";
export declare const XS_DEFAULT_CLASSES = "default_class_ref";
export declare const REFLECT_DESIGN_TYPE = "design:type";
export declare const METATYPE_SCHEMA = "schema";
export declare const METATYPE_ENTITY = "entity";
export declare const METATYPE_NAMESPACE = "namespace";
export declare const METATYPE_CLASS_REF = "class_ref";
export declare const METATYPE_PROPERTY = "property";
export declare const METATYPE_EMBEDDABLE = "object";
export type METADATA_TYPE = 'schema' | 'object' | 'entity' | 'property' | 'class_ref' | 'namespace';
export declare const BINDING_SCHEMA_ENTITY = "schema_entity";
export declare const BINDING_SCHEMA_CLASS_REF = "schema_class_ref";
export type METADATA_AND_BIND_TYPE = METADATA_TYPE | 'schema_entity' | 'entity_property' | 'property_entity' | 'schema_class_ref';
export type XS_DATA_TYPES = 'string' | 'number' | 'boolean' | 'entity' | 'array' | 'any';
export declare const XS_ID_SEPARATOR = "--";
export declare const XS_DEFAULT_SCHEMA = "default";
export declare const METADATA_REGISTRY = "metadata/registry";
export type ClassType<T> = {
    new (...args: any[]): T;
};
export type JS_DATA_TYPES = 'string' | 'text' | 'number' | 'boolean' | 'double' | 'json' | 'date' | 'time' | 'datetime' | 'timestamp' | 'byte' | 'object' | 'array' | 'symbol' | 'null' | 'undefined' | 'bigint';
export declare const XS_ANNOTATION_OPTIONS_CACHE = "anno_options_cache";
export declare const JS_DATA_TYPES: JS_DATA_TYPES[];
export declare const JS_PRIMATIVE_TYPES: JS_DATA_TYPES[];
export declare const C_EVENT_ADD = "add";
export declare const C_EVENT_REMOVE = "remove";
export declare const C_EVENT_UPDATE = "update";
export declare const C_EVENT_DRAIN_FINISHED = "drain_finished";
export declare const T_STRING = "string";
export declare const T_ARRAY = "array";
export declare const T_OBJECT = "object";
export declare const T_BOOLEAN = "boolean";
export declare const C_PROP_NAME = "name";
export declare const __CLASS__ = "__CLASS__";
export declare const __NS__ = "__NS__";
export declare const OPT_CREAT_AND_COPY = "createAndCopy";
export declare const STATE_KEY = "$state";
export declare const K_PATTERN_PROPERTY = "patternProperty";
export declare const K_TRIGGERED: unique symbol;
export type CLASS_TYPE = Function | ClassType<any>;
export type MERGE_TYPE = 'default' | 'assign' | 'merge';
export interface IMinMax {
    min: number;
    max: number;
}
export declare const DEFAULT_KEY_TO_SKIP: string[];
/**
 * Entity option signals that entity is generate by an other
 */
export declare const K_ENTITY_BUILT = "_built_";
export declare const DEFINED_PROPS_TO_OPTS: string[];
