import { JSONSchema7 } from 'json-schema';
import { IClassRef } from '../../api/IClassRef';
import { IEntityRef } from '../../api/IEntityRef';
export interface IJsonSchema7 extends JSONSchema7 {
    $target?: Function | IClassRef | IEntityRef;
    definitions?: {
        [key: string]: IJsonSchema7Definition;
    };
}
export type IJsonSchema7Definition = IJsonSchema7 | boolean;
export type IJsonSchema7TypeName = 'string' | 'number' | 'integer' | 'boolean' | 'object' | 'array' | 'null';
export declare const JSON_SCHEMA_7_TYPES: IJsonSchema7TypeName[];
export declare function hasClassInDefinition(name: string, def: IJsonSchema7): IJsonSchema7Definition;
export declare function hasClassPropertiesInDefinition(name: string, def: IJsonSchema7): {
    [key: string]: import("json-schema").JSONSchema7Definition;
};
