"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SerializerRegistry = void 0;
const JsonSchema_1 = require("../json-schema/JsonSchema");
class SerializerRegistry {
    static register(factory) {
        this.serializer[factory.getName()] = factory;
    }
    static get(name) {
        if (this.serializer[name]) {
            return this.serializer[name];
        }
        return null;
    }
}
exports.SerializerRegistry = SerializerRegistry;
SerializerRegistry.serializer = {};
SerializerRegistry.register(new JsonSchema_1.JsonSchema());
//# sourceMappingURL=SerializerRegistry.js.map